<?php
class qiwi {

    #    :
    public $iQiwiAccount, $aBalances = array( 'USD' => 0, 'RUB' => 0, 'EUR' => 0, 'KZT' => 0 );

    #    :
    private $sCookieFile, $sProxy, $sResponse, $aResponse;

    #  : .
    #  : Qiwi., ,     cookie,  .
    public function __construct( $iQiwiAccount, $sPassword, $sCookieFile, $sProxy = null ) {

        #   cookie   :
        if( !is_file( $sCookieFile ) ) {

            #      :
            if( !is_writeable( dirname( $sCookieFile ) ) ) {

                #   :
                throw new Exception( 'please, set chmod 777 for directory '.dirname( $sCookieFile ) );
            }

            #   :
            file_put_contents( $sCookieFile, '' );
        }

        #   cookie    :
        if( !is_writable( $sCookieFile ) ) {

            #   :
            throw new Exception( 'please, set chmod 777 for file '.$sCookieFile );
        }

        #    :
        $this->sCookieFile = $sCookieFile;
        $this->sProxy = $sProxy;

        #    :
        $this->curl( 'person/state.action' );

        #    :
        if( isset( $this->aResponse['data'] ) && isset( $this->aResponse['data']['person'] ) && isset( $this->aResponse['data']['balances'] ) && $this->aResponse['data']['person'] == $iQiwiAccount ) {

            #    :
            $this->iQiwiAccount = $this->aResponse['data']['person'];

            #     :
            foreach( $this->aResponse['data']['balances'] as $sEquivalent => $dBalance ) {

                #     :
                $this->aBalances[$sEquivalent] = $dBalance;
            }
            return;
        }

        #    :
        $this->curl( 'https://auth.qiwi.com/cas/tgts', json_encode( array( 'login' => '+'.$iQiwiAccount, 'password' => $sPassword ) ) );

        #      :
        if( isset( $this->aResponse['entity'] ) && isset( $this->aResponse['entity']['error'] ) && isset( $this->aResponse['entity']['error']['message'] ) )
            throw new Exception( mb_strtolower( $this->aResponse['entity']['error']['message'] ) );

        #      :
        if( !isset( $this->aResponse['entity'] ) || !isset( $this->aResponse['entity']['ticket'] ) )
            throw new Exception( 'ticket   - '.$this->sResponse );

        #    TGT 
        $sTGTToken = $this->aResponse['entity']['ticket'];

        #    :
        $this->curl( 'https://auth.qiwi.com/cas/sts', json_encode( array( 'service' => 'https://qiwi.com/j_spring_cas_security_check', 'ticket' => $sTGTToken ) ) );

        #      :
        if( isset( $this->aResponse['entity'] ) && isset( $this->aResponse['entity']['error'] ) && isset( $this->aResponse['entity']['error']['message'] ) )
            throw new Exception( mb_strtolower( $this->aResponse['entity']['error']['message'] ) );

        #      :
        if( !isset( $this->aResponse['entity'] ) || !isset( $this->aResponse['entity']['ticket'] ) )
            throw new Exception( 'ticket   - '.$this->sResponse );

        #    :
        $this->curl( 'https://qiwi.com/j_spring_cas_security_check?ticket='.$this->aResponse['entity']['ticket'] );

        #      :
        if( isset( $this->aResponse['message'] ) && $this->aResponse['message'] != '' )
            throw new Exception( $this->aResponse['message'] );

        #     :
        if( !isset( $this->aResponse['code'] ) || !isset( $this->aResponse['code']['_name'] ) || $this->aResponse['code']['_name'] != 'NORMAL' )
            throw new Exception( 'error authorize - '.$this->sResponse );

        #    qiwi. :
        $this->curl( 'person/state.action' );

        #   :
        if( !isset( $this->aResponse['data'] ) || !is_array( $this->aResponse['data'] ) || !isset( $this->aResponse['data']['person'] ) || !isset( $this->aResponse['data']['balances'] ) )
            throw new Exception( var_export( $this->aResponse, true ) );

        #    :
        $this->iQiwiAccount = $this->aResponse['data']['person'];

        #     :
        foreach( $this->aResponse['data']['balances'] as $sEquivalent => $dBalance ) {

            #    :
            $this->aBalances[$sEquivalent] = $dBalance;
        }
    }

    #  :  cookie.
    public function clearCookie() {

        #    :
        file_put_contents( $this->sCookieFile, '' );
    }

    #  :     Qiwi..
    #  : , , , .
    #  :   .
    public function transfer( $iQiwiAccount, $dAmount, $sCurrency, $sComment ) {
        return $this->payment( null, array( 'account' => '+'.$iQiwiAccount, 'comment' => $sComment ), $dAmount, $sCurrency, $sCurrency );
    }

    #  :     .
    #  :  ,  .
    public function getHistory( $sStartDate, $sFinishDate ) {

        #    :
        $this->curl( 'user/report/list.action?daterange=true&start='.$sStartDate.'&finish='.$sFinishDate );

        #   :
        $aTransactions = array();

        #   :
        foreach( explode( '</div><div class="reportsLine ', str_replace( '> <', '><', preg_replace( '!\s+!u', ' ', $this->sResponse ) ) ) as $iKey => $sValue )
        {

            #    :
            if( $iKey == 0 )
                continue;

            #   :
            $aData = array();

            #    :
            $aData['iID'] = explode( '<span class="value">', $sValue );
            if( count( $aData['iID'] ) < 2 )
                continue;
            $aData['iID'] = explode( '</', $aData['iID'][1] );
            $aData['iID'] = trim( $aData['iID'][0] );

            #     :
            $aData['sDate'] = explode( 'class="date">', $sValue );
            $aData['sDate'] = explode( '</', $aData['sDate'][1] );
            $aData['sDate'] = trim( $aData['sDate'][0] );
            $aData['sTime'] = explode( 'class="time">', $sValue );
            $aData['sTime'] = explode( '</', $aData['sTime'][1] );
            $aData['sTime'] = trim( $aData['sTime'][0] );

            #   :
            $aData['sAmount'] = explode( 'class="originalExpense"><span>', $sValue );
            $aData['sAmount'] = explode( '</', $aData['sAmount'][1] );
            $aData['sAmount'] = trim( $aData['sAmount'][0] );
            $aData['dAmount'] = preg_replace( '/[^0-9\.]+/', '', str_replace( ',', '.', $aData['sAmount'] ) ) - 0;

            #    :
            $aData['sCurrency'] = mb_strpos( $aData['sAmount'], '.' ) !== false ? 'RUB' : (mb_strpos( $aData['sAmount'], '.' ) !== false ? 'USD' : (mb_strpos( $aData['sAmount'], '.' ) !== false ? 'KZT' : 'NAN'));

            #      :
            $aData['sWithExpend'] = explode( 'WithExpend', $sValue );
            $aData['sWithExpend'] = explode( '</div>', $aData['sWithExpend'][1] );
            $aData['sWithExpend'] = explode( '<div class="cash">', $aData['sWithExpend'][0] );
            $aData['sWithExpend'] = trim( $aData['sWithExpend'][1] );
            $aData['dWithExpend'] = preg_replace( '/[^0-9\.]+/', '', str_replace( ',', '.', $aData['sWithExpend'] ) ) - 0;

            #     :
            $aData['iOpponentPhone'] = explode( 'class="opNumber">', $sValue );
            $aData['iOpponentPhone'] = explode( '</', $aData['iOpponentPhone'][1] );
            $aData['iOpponentPhone'] = trim( str_replace( '+', '', $aData['iOpponentPhone'][0] ) );

            #   :
            $aData['sComment'] = explode( 'class="comment">', $sValue );
            $aData['sComment'] = explode( '</', $aData['sComment'][1] );
            $aData['sComment'] = html_entity_decode( trim( $aData['sComment'][0] ), ENT_QUOTES, 'UTF-8' );

            #     :
            $aData['sProvider'] = explode( '<div class="provider"><span>', $sValue );
            $aData['sProvider'] = explode( '</span>', $aData['sProvider'][1] );
            $aData['sProvider'] = trim( $aData['sProvider'][0] );

            #    ?
            $aData['sType'] = mb_strpos( $sValue, 'IncomeWithExpend expenditure' ) !== false ? 'EXPENDITURE' : (mb_strpos( $sValue, 'IncomeWithExpend income' ) !== false ? 'INCOME' : 'NAN');

            #    :
            $aData['sStatus'] = explode( '"', $sValue );
            $aData['sStatus'] = str_replace( 'status_', '', trim( $aData['sStatus'][0] ) );

            #         :
            if( $aData['sStatus'] == 'ERROR' ) {
                $aData['sError'] = explode( '{"message":"', $sValue );
                $aData['sError'] = explode( '"', $aData['sError'][1] );
                $aData['sError'] = trim( $aData['sError'][0] );
            }

            #   :
            if( $aData['iID'] == false ) {
                $aData['iID'] = explode( '{"txn":', $sValue );
                $aData['iID'] = explode( '}', $aData['iID'][1] );
                $aData['iID'] = $aData['iID'][0];
            }

            $aTransactions['ID-'.$aData['iID']] = $aData;
        }

        return $aTransactions;
    }

    #  :    .
    #  :  ,  - ,  - .
    public function getBalances() {

        #    :
        $this->curl( 'person/state.action' );

        #      :
        if( !isset( $this->aResponse['data'] ) || !isset( $this->aResponse['data']['person'] ) || !isset( $this->aResponse['data']['balances'] ) )
            throw new Exception( 'bad server answer' );

        #   :
        $this->iQiwiAccount = $this->aResponse['data']['person'];

        #   :
        foreach( $this->aResponse['data']['balances'] as $sEquivalent => $dBalance ) {

            #     :
            $this->aBalances[$sEquivalent] = $dBalance;
        }

        return $this->aBalances;
    }

    #  :  .
    private function payment( $iProvider, array $aExtra, $dAmount, $sCurrency = 'RUB', $sPayCurrency = 'RUB' ) {

        #    :
        $dAmount = intval( str_replace( ',', '.', $dAmount ) * 100 ) / 100;
        $aAmount = explode( '.', $dAmount );
        if( !isset( $aAmount[1] ) )
            $aAmount[1] = '00';
        else if( strlen( $aAmount[1] ) != 2 )
            $aAmount[1] .= '0';

        #   aExtra :
        foreach( $aExtra as $sKey => $sValue ) {
            $aExtra["extra['".$sKey."']"] = $sValue;
            unset( $aExtra[$sKey] );
        }

        #      :
        $this->curl( is_null( $iProvider ) ? 'payment/transfer/form.action' : 'payment/form.action?provider='.$iProvider );

        #      :
        $this->curl(
            'user/payment/form/state.action?'.http_build_query(
                array_merge( array(
                    'amountInteger' => $aAmount[0],
                    'amountFraction' => $aAmount[1],
                    'arg_num' => '',
                    'currency' => $sCurrency,
                    'protected' => 'true',
                    'source' => 'qiwi_'.$sPayCurrency,
                    'state' => 'CONFIRM'
                ), $aExtra )
            )
        );

        #    :
        if( !isset( $this->aResponse['data'] ) || !isset( $this->aResponse['data']['token'] ) )
            throw new Exception( isset( $this->aResponse['message'] ) ? $this->aResponse['message'] : 'internal error, step 2' );

        #     :
        $this->curl(
            'user/payment/form/state.action?'.http_build_query(
                array_merge( array(
                    'amountInteger' => $aAmount[0],
                    'amountFraction' => $aAmount[1],
                    'arg_num' => '',
                    'currency' => $sCurrency,
                    'protected' => 'true',
                    'source' => 'qiwi_'.$sPayCurrency,
                    'state' => 'CONFIRM',
                    'token' => $this->aResponse['data']['token'],
                ), $aExtra )
            )
        );

        #       :
        $this->curl( 'payment/form/state.action?state=PAY' );

        #    :
        if( !isset( $this->aResponse['data'] ) || !isset( $this->aResponse['data']['token'] ) )
            throw new Exception( isset( $this->aResponse['message'] ) ? $this->aResponse['message'] : 'internal error, step 4' );

        #    :
        $this->curl(
            'payment/form/state.action',
            array(
                'token' => $this->aResponse['data']['token'],
                'state' => 'PAY'
            )
        );

        #      :
        if( mb_strpos( $this->sResponse, 'transaction":"' ) === false ) {
            if( mb_strpos( $this->sResponse, 'class="errorElement"' ) !== false ) {
                $aExplode = explode( 'class="errorElement">', $this->sResponse );
                $aExplode = explode( '</', $aExplode[1] );
                throw new Exception( trim( $aExplode[0] ) );
            }
            # ,   SMS   :
            else if( mb_strpos( $this->sResponse, 'confirmPage' ) !== false )
                return false;
            else {
                if( count( $sMessage = explode( '<p>', $this->sResponse ) ) < 2 )
                    throw new Exception( 'unknown error' );
                $sMessage = explode( '</p>', $sMessage[1] );
                throw new Exception( $sMessage[0] );
            }
        }

        #   - Qiwi  :
        if( $iProvider == 22496 ) {
            if( count( $aExplode = explode( ' :', $this->sResponse ) ) < 2 )
                throw new Exception( 'error parse egg' );
            $aExplode = explode( '</', $aExplode[1] );
            return trim( $aExplode[0] );
        }

        #    :
        $aHistory = $this->getHistory( date( 'd.m.Y', strtotime( '-1 day' ) ), date( 'd.m.Y', strtotime( '+1 day' ) ) );
        $aTransfer = array_shift( $aHistory );
        if( $aTransfer === false || $aTransfer['dAmount'] != $dAmount || $aTransfer['sCurrency'] != $sCurrency )
            throw new Exception( 'transfer not found in history' );
        return $aTransfer['iID'];
    }

    #  :   SMS .
    #  : true - SMS , false - SMS .
    public function isSMSActive() {

        #   :
        $this->curl( 'options/security.action' );

        #     :
        if( count( $aExplode = explode( 'SMS_CONFIRMATION', $this->sResponse ) ) < 3 )
            throw new Exception( 'error check sms confirmation' );

        return strpos( $aExplode[1], 'display' ) === false;
    }

    #  :  QIWI .
    #  : , .
    #  :  .
    public function createEgg( $dAmount, $sComment ) {
        return $this->payment( 22496, array( 'account' => '708', 'comment' => $sComment, 'to_account' => '', 'to_account_type' => 'undefind' ), $dAmount );
    }

    #  :  QIWI .
    #  :  .
    #     : dAmount - , sComment - .
    public function activateEgg( $sCode ) {

        #     :
        if( $sCode == '' )
            throw new Exception( 'voucher code Unknown' ); #throw new Exception( '   ' );

        #   :
        $aResult = array(); #  

        #   :
        $this->curl( 'user/eggs/activate/content/form.action', array( 'code' => $sCode ) );

        #     :
        if( !isset( $this->aResponse['data'] ) || !isset( $this->aResponse['data']['token'] ) )
            throw new Exception( 'error in step 1' );

        #   :
        $this->curl( 'user/eggs/activate/content/form.action', array( 'code' => $sCode, 'token' => $this->aResponse['data']['token'] ) );

        #     :
        if( mb_substr_count( $this->sResponse, $sCode ) != 2 ) {
            if( count( $aExplode = explode( '<p>', $this->sResponse ) ) < 3 )
                throw new Exception( 'undefined error' );
            $aExplode = explode( '</', $aExplode[2] );
            throw new Exception( trim( strip_tags( $aExplode[0] ) ) );
        }

        #   :
        if( count( $aExplode = explode( ' ', $this->sResponse ) ) < 2 )
            throw new Exception( 'error parse amount' );
        $aExplode = explode( '', $aExplode[1] );
        $aResult['dAmount'] = preg_replace( '/[^0-9\.]+/', '', str_replace( ',', '.', trim( $aExplode[0] ) ) ) - 0;

        #   :
        if( count( $aExplode = explode( '  ', $this->sResponse ) ) < 2 )
            throw new Exception( 'error parse comment' );
        $aExplode = explode( '</p>', $aExplode[1] );
        $aResult['sComment'] = trim( strip_tags( $aExplode[0] ) );

        #    :
        $this->curl( 'user/eggs/activate/content/activate.action', array( 'code' => $sCode ) );

        #   :
        if( !isset( $this->aResponse['code'] ) || !isset( $this->aResponse['code']['value'] ) || !isset( $this->aResponse['code']['_name'] ) || $this->aResponse['code']['value'] != '0' || $this->aResponse['code']['_name'] != 'NORMAL' )
            throw new Exception( 'bad server answer: '.var_export( $this->aResponse, true ) );

        return $aResult;
    }

    public function requestChangePassword() {

        #   :
        $this->curl( 'options/password.action' );

        #   :
        $this->curl( 'user/person/change/password.action' );

        #   :
        $iIdentifier = isset( $this->aResponse['identifier'] ) ? $this->aResponse['identifier'] - 0 : 0;

        #   <= 0 :
        if( $iIdentifier <= 0 )
            throw new Exception( 'field identifier not found' );

        #   :
        $this->curl( 'user/confirmation/form.action', array(
            'identifier' => $iIdentifier,
            'type' => 'PASSWORD_CHANGE'
        ) );

        return $iIdentifier;
    }

    public function progressChangePassword( $iIdentifier, $sOldPassword, $sNewPassword, $iCode ) {

        #   :
        $this->curl( 'user/confirmation/confirm.action', array(
            'code' => $iCode,
            "data['newPassword']" => $sNewPassword,
            "data['oldPassword']" => $sOldPassword,
            "data['period']" => 4,
            'identifier' => $iIdentifier,
            'type' => 'PASSWORD_CHANGE'
        ) );

        #     :
        if( !isset( $this->aResponse['code'] ) || !isset( $this->aResponse['code']['value'] ) || $this->aResponse['code']['value'] != 0 )
            throw new Exception( isset( $this->aResponse['message'] ) ? $this->aResponse['message'] : json_encode( $this->aResponse ) );
    }

    public function requestConfirmPayments( $bOff = true ) {

        #   :
        $this->curl( 'settings/options/security.action' );

        #   :
        $this->curl( 'user/person/change/security.action', array(
            'type' => 'SMS_CONFIRMATION',
            'value' => $bOff ? 'false' : 'true'
        ) );

        #   :
        if( !isset( $this->aResponse['code'] ) || !isset( $this->aResponse['code']['value'] ) || $this->aResponse['code']['value'] != 7 || !isset( $this->aResponse['data'] ) || !isset( $this->aResponse['data']['token'] ) )
            throw new Exception( json_encode( $this->aResponse ) );

        #   :
        $sToken = $this->aResponse['data']['token'];

        #   :
        $this->curl( 'user/person/change/security.action', array(
            'token' => $sToken,
            'type' => 'SMS_CONFIRMATION',
            'value' => $bOff ? 'false' : 'true'
        ) );

        #   :
        if( isset( $this->aResponse['code'] ) && isset( $this->aResponse['code']['value'] ) && $this->aResponse['code']['value'] == 0 )
            return true;

        #   :
        if( !isset( $this->aResponse['code'] ) || !isset( $this->aResponse['code']['value'] ) || $this->aResponse['code']['value'] != 4 || !isset( $this->aResponse['identifier'] ) || $this->aResponse['identifier'] <= 0 )
            throw new Exception( json_encode( $this->aResponse ) );

        #   :
        $iIdentifier = $this->aResponse['identifier'];

        #   :
        $this->curl( 'user/confirmation/form.action', array(
            'identifier' => $iIdentifier,
            'token' => $sToken,
            'type' => 'SMS_CONFIRMATION',
            'value' => $bOff ? 'false' : 'true'
        ) );

        return $iIdentifier;
    }

    public function progressConfirmPayments( $iIdentifier, $iCode ) {

        #   :
        $this->curl( 'user/confirmation/confirm.action', array(
            'code' => $iCode,
            'identifier' => $iIdentifier,
            'type' => 'SMS_CONFIRMATION'
        ) );

        #     :
        if( !isset( $this->aResponse['code'] ) || !isset( $this->aResponse['code']['value'] ) || $this->aResponse['code']['value'] != 0 )
            throw new Exception( isset( $this->aResponse['message'] ) ? $this->aResponse['message'] : json_encode( $this->aResponse ) );
    }

    public function paymentSMSConfirm( $iCode ) {

        #   :
        $this->curl( 'user/payment/form/state.action', array(
            'confirmationCode' => $iCode,
            'protected' => 'true',
            'state' => 'PAY'
        ) );

        #   :
        $this->curl( 'user/payment/form/state.action', array(
            'confirmationCode' => $iCode,
            'protected' => 'true',
            'state' => 'PAY',
            'token' => $this->aResponse['data']['token']
        ) );

        #      :
        if( mb_strpos( $this->sResponse, 'transaction":"' ) === false ) {
            if( mb_strpos( $this->sResponse, 'class="errorElement"' ) !== false ) {
                $aExplode = explode( 'class="errorElement">', $this->sResponse );
                $aExplode = explode( '</', $aExplode[1] );
                throw new Exception( trim( $aExplode[0] ) );
            }
            if( count( $sMessage = explode( '<p>', $this->sResponse ) ) < 2 )
                throw new Exception( 'unknown error' );
            $sMessage = explode( '</p>', $sMessage[1] );
            throw new Exception( $sMessage[0] );
        }

        #    :
        if( count( $aExplode = explode( ' :', $this->sResponse ) ) > 1 ) {
            $aExplode = explode( '<', $aExplode[1] );
            return trim( $aExplode[0] );
        }

        #    :
        $aExplode = explode( 'transaction":"', $this->sResponse );
        $aExplode = explode( '"', $aExplode[1] );
        return $aExplode[0];
    }

    #  :   .
    private function curl( $sPath, $mPOST = null, array $aOptions = null ) {

        #    :
        static $sReferer = null;

        #   :
        $oCurl = curl_init( mb_substr( $sPath, 0, 4 ) == 'http' ? $sPath : 'https://qiwi.com/'.$sPath );

        #  cURL :
        curl_setopt_array( $oCurl, array(
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_COOKIEJAR => $this->sCookieFile,
            CURLOPT_COOKIEFILE => $this->sCookieFile,
            CURLOPT_USERAGENT => 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0',
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_SSL_VERIFYHOST => false,
            CURLOPT_HTTPHEADER => mb_substr( $sPath, 0, 4 ) == 'http' ? (is_null( $mPOST ) ? array( 'Accept: application/json, text/javascript, */*; q=0.01', 'X-Requested-With: XMLHttpRequest' ) : array( 'Content-Type: application/json; charset=UTF-8' )) : array( 'Accept: application/json, text/javascript, */*; q=0.01', 'X-Requested-With: XMLHttpRequest' ),
        ) );

        #    POST -  :
        if( is_array( $mPOST ) || $mPOST != '' || mb_substr( $sPath, 0, 4 ) != 'http' ) {

            #  Curl  :
            curl_setopt_array( $oCurl, array(
                CURLOPT_POST => true,
                CURLOPT_POSTFIELDS => is_array( $mPOST ) ? http_build_query( $mPOST ) : $mPOST,
            ) );
        }

        #    :
        if( !is_null( $sReferer ) )
            curl_setopt( $oCurl, CURLOPT_REFERER, $sReferer );

        #      :
        if( is_array( $aOptions ) && count( $aOptions ) )
            curl_setopt_array( $oCurl, $aOptions );

        #     Proxy :
        if( $this->sProxy != '' ) {

            #       :
            $aExplode = explode( ':', $this->sProxy );

            #    > 2 :
            if( count( $aExplode ) > 2 ) {

                #  proxy  curl:
                curl_setopt_array( $oCurl, array(
                    CURLOPT_PROXY => $aExplode[0].':'.$aExplode[1],
                    CURLOPT_HTTPPROXYTUNNEL => true,
                    CURLOPT_TIMEOUT => 10,
                    CURLOPT_PROXYTYPE => $aExplode[2] == 'socks5' ? CURLPROXY_SOCKS5 : ($aExplode[2] == 'socks4' ? CURLPROXY_SOCKS4 : CURLPROXY_HTTP)
                ) );

                #     4 :
                if( count( $aExplode ) > 4 ) {

                    #   proxy  curl:
                    curl_setopt( $oCurl, CURLOPT_PROXYUSERPWD, $aExplode[3].':'.$aExplode[4] );
                }
            }
        }

        #   :
        $this->sResponse = curl_exec( $oCurl );

        #    :
        if( curl_errno( $oCurl ) )
            throw new Exception( curl_errno( $oCurl ).' - '.curl_error( $oCurl ) );

        #   :
        curl_close( $oCurl );

        #   referer :
        $sReferer = mb_substr( $sPath, 0, 4 ) == 'http' ? $sPath : 'https://qiwi.com/'.$sPath;

        #     :
        $this->aResponse = json_decode( $this->sResponse, true );
        if( json_last_error() != JSON_ERROR_NONE )
            $this->aResponse = array();

        return $this->sResponse;
    }
}

?>